
Redmine - Defect #33253

Failed to upgrade to v4.1

2020-04-04 17:48 - sdp kc

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Database Estimated time: 0.00 hour

Target version:    

Resolution: Invalid Affected version: 4.1.0

Description

I am trying to upgrade to 4.1.0 from 4.0.3.stable and its failing to upgrade. I am using docker. I have included the log below:

Resolving dependencies...

Using rake 13.0.1

Using concurrent-ruby 1.1.6

Using minitest 5.14.0

Using thread_safe 0.3.6

Using builder 3.2.4

Using mini_portile2 2.4.0

Using crass 1.0.6

Using rack 2.2.2

Using nio4r 2.5.2

Using websocket-extensions 0.1.4

Using mini_mime 1.0.2

Using method_source 1.0.0

Using thor 1.0.1

Using arel 9.0.0

Using mimemagic 0.3.4

Using public_suffix 4.0.3

Using bundler 1.17.2

Using csv 3.1.2

Using temple 0.8.2

Using tilt 2.0.10

Using htmlentities 4.3.4

Using mini_magick 4.9.5

Using mysql2 0.5.3

Using net-ldap 0.16.2

Using ruby-openid 2.9.2

Using rbpdf-font 1.19.1

Using redcarpet 3.5.0

Using rouge 3.12.0

Using erubi 1.9.0

Using i18n 1.6.0

Using tzinfo 1.2.6

Using nokogiri 1.10.9

Using websocket-driver 0.7.1

Using mail 2.7.1

Using marcel 0.3.3

Using addressable 2.7.0

Using haml 5.1.2

Using rack-openid 1.4.2

Using sprockets 4.0.0

Using rbpdf 1.20.1

Using request_store 1.4.1

Using rack-test 1.1.0

Using activesupport 5.2.4.1

Using loofah 2.4.0

Using css_parser 1.7.1

Using rails-dom-testing 2.0.3

Using rails-html-sanitizer 1.3.0

Using globalid 0.4.2
Using activemodel 5.2.4.1

Using roadie 4.0.0

Using activerecord 5.2.4.1

Using actionview 5.2.4.1

Using actionpack 5.2.4.1

Using activejob 5.2.4.1

Using actioncable 5.2.4.1

Using railties 5.2.4.1

Using activestorage 5.2.4.1

Using sprockets-rails 3.2.1

Using actionmailer 5.2.4.1

Using actionpack-xml_parser 2.0.1

Using roadie-rails 2.1.1

Using rails 5.2.4.1

Bundle complete! 36 Gemfile dependencies, 62 gems now installed.

Gems in the groups development and test were not installed.

Use `bundle info [gemname]` to see where a bundled gem is installed.

rake aborted!

StandardError: An error has occurred, all later migrations canceled:

Mysql2::Error: Duplicate column name 'unique_id': ALTER TABLE `import_items` ADD `unique_id` varch

ar(255)

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:131:in `_query'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:131:in `block in query'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:130:in `handle_interrupt'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:130:in `query'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_mysql_a

dapter.rb:187:in `block (2 levels) in execute'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/dependencies/interlock.rb:48:in `b

lock in permit_concurrent_loads'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/concurrency/share_lock.rb:187:in `

yield_shares'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/dependencies/interlock.rb:47:in `p

ermit_concurrent_loads'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_mysql_a

dapter.rb:186:in `block in execute'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_adapter

.rb:581:in `block (2 levels) in log'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_adapter

.rb:580:in `block in log'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/notifications/instrumenter.rb:23:i

n `instrument'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_adapter

.rb:571:in `log'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_mysql_a

dapter.rb:185:in `execute'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/mysql/database_s

tatements.rb:28:in `execute'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

statements.rb:581:in `add_column'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:527:in `column'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:232:in `block in string'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:232:in `each'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:232:in `string'

/usr/src/redmine/db/migrate/20190510070108_add_unique_id_to_import_items.rb:4:in `block in change'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

statements.rb:471:in `change_table'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:871:in `block in method

_missing'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:840:in `block in say_wi

th_time'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:840:in `say_with_time'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:860:in `method_missing'
/usr/src/redmine/db/migrate/20190510070108_add_unique_id_to_import_items.rb:3:in `change'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:814:in `exec_migration'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:798:in `block (2 levels

) in migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:797:in `block in migrat

e'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/connect

ion_pool.rb:416:in `with_connection'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:796:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:977:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1292:in `block in execu

te_migration_in_transaction'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1345:in `ddl_transactio

n'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1291:in `execute_migrat

ion_in_transaction'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1263:in `block in migra

te_without_lock'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1262:in `each'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1262:in `migrate_withou

t_lock'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1210:in `block in migra

te'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1363:in `with_advisory_

lock'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1210:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1036:in `up'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1011:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/tasks/database_tasks.rb:172:in `migr

ate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/railties/databases.rake:60:in `block

 (2 levels) in <top (required)>'

/usr/local/bundle/gems/rake-13.0.1/exe/rake:27:in `<top (required)>'

Caused by:

ActiveRecord::StatementInvalid: Mysql2::Error: Duplicate column name 'unique_id': ALTER TABLE `imp

ort_items` ADD `unique_id` varchar(255)

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:131:in `_query'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:131:in `block in query'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:130:in `handle_interrupt'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:130:in `query'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_mysql_a

dapter.rb:187:in `block (2 levels) in execute'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/dependencies/interlock.rb:48:in `b

lock in permit_concurrent_loads'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/concurrency/share_lock.rb:187:in `

yield_shares'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/dependencies/interlock.rb:47:in `p

ermit_concurrent_loads'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_mysql_a

dapter.rb:186:in `block in execute'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_adapter

.rb:581:in `block (2 levels) in log'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_adapter

.rb:580:in `block in log'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/notifications/instrumenter.rb:23:i

n `instrument'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_adapter

.rb:571:in `log'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_mysql_a

dapter.rb:185:in `execute'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/mysql/database_s

tatements.rb:28:in `execute'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

statements.rb:581:in `add_column'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:527:in `column'
/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:232:in `block in string'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:232:in `each'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:232:in `string'

/usr/src/redmine/db/migrate/20190510070108_add_unique_id_to_import_items.rb:4:in `block in change'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

statements.rb:471:in `change_table'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:871:in `block in method

_missing'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:840:in `block in say_wi

th_time'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:840:in `say_with_time'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:860:in `method_missing'

/usr/src/redmine/db/migrate/20190510070108_add_unique_id_to_import_items.rb:3:in `change'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:814:in `exec_migration'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:798:in `block (2 levels

) in migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:797:in `block in migrat

e'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/connect

ion_pool.rb:416:in `with_connection'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:796:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:977:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1292:in `block in execu

te_migration_in_transaction'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1345:in `ddl_transactio

n'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1291:in `execute_migrat

ion_in_transaction'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1263:in `block in migra

te_without_lock'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1262:in `each'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1262:in `migrate_withou

t_lock'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1210:in `block in migra

te'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1363:in `with_advisory_

lock'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1210:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1036:in `up'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1011:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/tasks/database_tasks.rb:172:in `migr

ate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/railties/databases.rake:60:in `block

 (2 levels) in <top (required)>'

/usr/local/bundle/gems/rake-13.0.1/exe/rake:27:in `<top (required)>'

Caused by:

Mysql2::Error: Duplicate column name 'unique_id'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:131:in `_query'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:131:in `block in query'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:130:in `handle_interrupt'

/usr/local/bundle/gems/mysql2-0.5.3/lib/mysql2/client.rb:130:in `query'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_mysql_a

dapter.rb:187:in `block (2 levels) in execute'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/dependencies/interlock.rb:48:in `b

lock in permit_concurrent_loads'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/concurrency/share_lock.rb:187:in `

yield_shares'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/dependencies/interlock.rb:47:in `p

ermit_concurrent_loads'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_mysql_a

dapter.rb:186:in `block in execute'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_adapter

.rb:581:in `block (2 levels) in log'
/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_adapter

.rb:580:in `block in log'

/usr/local/bundle/gems/activesupport-5.2.4.1/lib/active_support/notifications/instrumenter.rb:23:i

n `instrument'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_adapter

.rb:571:in `log'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract_mysql_a

dapter.rb:185:in `execute'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/mysql/database_s

tatements.rb:28:in `execute'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

statements.rb:581:in `add_column'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:527:in `column'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:232:in `block in string'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:232:in `each'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

definitions.rb:232:in `string'

/usr/src/redmine/db/migrate/20190510070108_add_unique_id_to_import_items.rb:4:in `block in change'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/schema_

statements.rb:471:in `change_table'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:871:in `block in method

_missing'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:840:in `block in say_wi

th_time'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:840:in `say_with_time'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:860:in `method_missing'

/usr/src/redmine/db/migrate/20190510070108_add_unique_id_to_import_items.rb:3:in `change'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:814:in `exec_migration'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:798:in `block (2 levels

) in migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:797:in `block in migrat

e'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/connection_adapters/abstract/connect

ion_pool.rb:416:in `with_connection'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:796:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:977:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1292:in `block in execu

te_migration_in_transaction'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1345:in `ddl_transactio

n'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1291:in `execute_migrat

ion_in_transaction'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1263:in `block in migra

te_without_lock'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1262:in `each'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1262:in `migrate_withou

t_lock'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1210:in `block in migra

te'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1363:in `with_advisory_

lock'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1210:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1036:in `up'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/migration.rb:1011:in `migrate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/tasks/database_tasks.rb:172:in `migr

ate'

/usr/local/bundle/gems/activerecord-5.2.4.1/lib/active_record/railties/databases.rake:60:in `block

 (2 levels) in <top (required)>'

/usr/local/bundle/gems/rake-13.0.1/exe/rake:27:in `<top (required)>'

Tasks: TOP => db:migrate

(See full trace by running task with --trace)

I, [2020-04-04T15:39:39.835342 #49]  INFO -- : Migrating to AddUniqueIdToImportItems (201905100701

08)

== 20190510070108 AddUniqueIdToImportItems: migrating =========================
-- change_table(:import_items)

History

#1 - 2020-04-05 09:03 - Marius BĂLTEANU

- Description updated

- Status changed from New to Needs feedback

Did you have any patch applied or plugin installed on 4.0.3? I'm asking because the column is added in 4.1.0.

#2 - 2020-04-05 16:43 - sdp kc

Yes, i have following plugins installed

Redmine Dashboard plugin : https://github.com/jgraichen/redmine_dashboard

Redmine Pivot Table plugin: https://github.com/deecay/redmine_pivot_table

#3 - 2020-04-05 17:01 - sdp kc

- File F7DAEB9E-50A4-4EDF-BFEA-D57BE1896E43.jpeg added

I have attached the screenshot of the info page of my installation.

#4 - 2020-04-10 20:23 - sdp kc

I tried with v4.1.1 and had same issue.

#5 - 2020-04-11 10:36 - Marius BĂLTEANU

I don't know why the `unique_id` column already exists on your database.

You have two options:

1. You inspect your import_items table from your database and drop the column unique_id in order for the migration to recreate the column.

2. You comment in the migration files this line that adds the column.

I advise you to be careful with both operations and to do it only if you have enough experience with databases and the most important, backups in

place that allows you to revert to the current state of your installation.

#6 - 2020-04-11 17:56 - sdp kc

Thank you.

Issues seems to be in MariaDb v10.1.44

I commented this line and upgrade completed without issue

#7 - 2020-04-12 18:16 - Marius BĂLTEANU

- Status changed from Needs feedback to Closed

- Resolution set to Invalid

Files

F7DAEB9E-50A4-4EDF-BFEA-D57BE1896E43.jpeg 82.6 KB 2020-04-05 sdp kc
